;;;-*- Mode: Lisp; Syntax: Common-Lisp; Base: 10; Package: accessors -*-
#|
This code was developed in the joint research project APPLY funded by
the German Ministry of Research and Technology under the project code
ITW9102D5.

Copyright 1994-2010 Fraunhofer ISST

Licensed under the EUPL, Version 1.1 or  as soon they will be approved by the European Commission - subsequent 
versions of the EUPL (the "Licence");

You may not use this work except in compliance with the Licence.
You may obtain a copy of the Licence at:
http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
Unless required by applicable law or agreed to in
writing, software distributed under the Licence is distributed on an "AS IS" basis,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.

See the Licence for the specific language governing permissions and limitations under the Licence.

-----------------------------------------------------------------------------------
TITLE: 
-----------------------------------------------------------------------------------
File:    accessors.em
Version: 2.0 (last modification on Fri Mar 11 18:22:44 1994)
State:   proposed

DESCRIPTION:


DOCUMENTATION:


NOTES:


REQUIRES:


PROBLEMS:


AUTHOR:
horst friedrich

CONTACT: 
horst friedrich

HISTORY: 
Log for /export/home/saturn/ukriegel/Eu2C/Apply/accessors.em[2.0]:
  accessors.lisp as module
[1.1] Fri Nov 26 10:26:54 1993 imohr@isst proposed
  lzs and mzs as modules ok.
[1.2] Thu Jan 13 15:49:10 1994 imohr@isst saved
  [Thu Jan  6 14:51:04 1994] Intention for change:
  + get-slot-value, set-slot-value
[1.3] Tue Jan 25 10:36:14 1994 wheick@isst published
  new accessor from andreas
[1.4] Thu Feb 17 11:28:33 1994 wheick@isst proposed
  [Thu Feb 17 11:09:56 1994] Intention for change:
  copyright
[1.5] Thu May  5 11:49:20 1994 imohr@isst proposed
  separate compilation of eulisp0
[2.0] Thu May  5 11:49:20 1994 imohr@isst proposed
  separate compilation of eulisp0

-----------------------------------------------------------------------------------
|#

#module accessors

(import ((except (concatenate) eulisp0)
         (only (intern concatenate string)
           common-lisp))
 syntax (eulisp0))

(defmacro defaccessors aclist
  `(progn ,@(da1 aclist)))

(defun da1 (aclist)
  (if (null aclist) ()
      (let ((el (car aclist)))
        `(,(mk!acc el)
          ,(ex!acc el)
          ,(mk?acc el)
          ,(ex?acc el)
          ,@(da1 (cdr aclist)))
        )))

(defun mk!acc (sym)
  `(defgeneric ,(intern (concatenate 'cl:string "!" (string sym)))
     (arg what)))

(defun mk?acc (sym)
  `(defgeneric ,(intern (concatenate 'cl:string "?" (string sym)))
     (arg)))

(defun ex!acc (sym) 
  `(export ,(intern (concatenate 'cl:string "!" (string sym)))))

(defun ex?acc (sym) 
  `(export ,(intern (concatenate 'cl:string "?" (string sym)))))


(defaccessors ; --- structure slots of LZS ---
allow-other-keys
arg
arg-list
body
case-list
class
class-def-list
constant-value
cont
converter
direct-slots
domain
else
exported
first-form
form
form-list
fun
fun-list
function
init
init-list
initarg
initfunction
instance
key-list
location
method-class
method-list
name
named-const-list
opt-list
options
otherwise
package
params
pred
rest
setter
slot
supers
suppl
sym
sym-list
tagbody
tagged-form-list
then
toplevel-forms
value
value-list
var
var-list
)

(defaccessors ; --- annotation slots of LZS ---
accessor
actual
allocator
applications
arg-num
c-imports
calls
class-precedence-list
closure
closure-vars
code-identifier
constructor-for
constructors
copy-fun
definition
discriminating-fun
discrimination-arguments
discrimination-depth
effective-slots
equal-pred
expanded
expanded-literal
exports
fread-gloc
function-label
function-type
fwrite-gloc
gc-not-needed
gc-tracer
generic-fun
identifier
initargs
initial-value
initialization
initvalue
inline
interpreter
label
language
lattice-type
lex-env
link
match-list
method-lookup-fun
module
moves
get-slot-value
set-slot-value
offset
pass
place
predicate
protocol-type
range-and-domain
read-gloc
read-gloc-list
read-glocs
read-stats
reader
rec-calls
reduce
representation
signature
slot-of
specializes
statement-status
subclasses
syntactic
syntax-env
syntax-exports
sys-glocs
tests
type
type-descr
type-descr-s
type-identifier
type-list
used-runtime-modules
used-syntax-modules
var-descr
write-gloc
write-gloc-list
write-glocs
write-stats
writer
)

(defaccessors ; --- structure slots of MZS ---
;NOTE that some structure slots of the MZS have the same name as annotation
;slots of the LZS
application
basis
block
closure-call
constant-counter
context
data-type
else-block
end-blocks
error-spec
in-block
in-label
interface
killed-places
new-type-vars
num
out-block
out-blocks
out-label
rclass
ready
result
rnumber
start-block
stat
t-descr-before
then-block
tnr
type-spec
type-vars
type-vec
used-places
value-type
var-vec
)

(defaccessors ; --- annotation slots of MZS ---
divided
else-interface
else-type-descr-s
env
env-level
in-binding
kill-binding
out-binding
pathes
rebind-vars
successor-blocks
t-descr-after
t-path
then-type-descr-s
)

#module-end ;end of module accessors