;;;-*- Mode: Lisp; Syntax: Common-Lisp; Base: 10; Package: arg-context -*-
#|
This code was developed in the joint research project APPLY funded by
the German Ministry of Research and Technology under the project code
ITW9102D5.

Copyright 1994-2010 Fraunhofer ISST

Licensed under the EUPL, Version 1.1 or  as soon they will be approved by the European Commission - subsequent 
versions of the EUPL (the "Licence");

You may not use this work except in compliance with the Licence.
You may obtain a copy of the Licence at:
http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
Unless required by applicable law or agreed to in
writing, software distributed under the Licence is distributed on an "AS IS" basis,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.

See the Licence for the specific language governing permissions and limitations under the Licence.

-----------------------------------------------------------------------------------
TITLE: 
-----------------------------------------------------------------------------------
File:    arg-context.em
Version: 2.0 (last modification on Fri Feb 25 14:43:26 1994)
State:   proposed

DESCRIPTION:
DOCUMENTATION:
NOTES:
REQUIRES:
PROBLEMS:
AUTHOR: Dr. Horst Firedrich
CONTACT: horst.friedrich@isst.fhg.de
HISTORY: 
Log for /export/home/saturn/ukriegel/Eu2C/Apply/arg-context.em[2.0]:
  
[1.1] Fri Mar  5 13:00:57 1993 hfried@isst saved
  [Fri Mar  5 12:05:09 1993] Intention for change:
  test
  text
[1.2] Thu Mar 18 08:59:13 1993 hfried@isst proposed
  [Fri Mar  5 13:03:07 1993] Intention for change:
[1.3] Wed Mar 24 13:47:55 1993 hfried@isst proposed
  [Thu Mar 18 09:10:43 1993] Intention for change:
  + glob anna
[1.4] Thu Mar 25 11:18:51 1993 hfried@isst proposed
  [Wed Mar 24 14:52:43 1993] Intention for change:
  + gen-fun
  new head
[1.5] Tue Apr 13 14:08:35 1993 hfried@isst proposed
  [Thu Mar 25 11:53:44 1993] Intention for change:
[1.6] Mon Jun 21 11:34:28 1993 hfried@isst saved
  [Tue Apr 13 14:14:58 1993] Intention for change:
[1.7] Mon Jun 21 11:36:05 1993 hfried@isst saved
  [Mon Jun 21 11:35:52 1993] Intention for change:
[1.8] Wed Jun 30 10:42:47 1993 hfried@isst saved
  [Tue Jun 29 11:14:40 1993] Intention for change:
  inline slot-accessor-fun
[1.9] Thu Aug 26 11:46:31 1993 hfried@isst published
  [Mon Aug 23 16:01:54 1993] Intention for change:
  closure-function 
[1.10] Wed Jan 19 13:05:15 1994 hfried@isst saved
  [Mon Jan 17 13:02:18 1994] Intention for change:
  slot-value
[1.11] Mon Jan 31 09:29:25 1994 akind@isst published
  [Thu Jan 20 14:54:24 1994] Intention for change:
  update import
[1.12] Wed Feb 16 07:50:12 1994 imohr@isst proposed
  [Wed Feb 16 07:48:22 1994] Intention for change:
  repair call of inline-a: 4 arguments are needed
[1.13] Mon Feb 28 14:47:46 1994 wheick@isst proposed
  [Fri Feb 25 13:34:15 1994] Intention for change:
  insert eulisp0,1
  <spint> => <fpi>
  done
[2.0] Mon Feb 28 14:47:46 1994 wheick@isst proposed
  [Fri Feb 25 13:34:15 1994] Intention for change:
  insert eulisp0,1
  <spint> => <fpi>
  done


-----------------------------------------------------------------------------------
|#

#module arg-context
(import 
 (eulisp1
  SIMPLE-PROGRAMMING
  LZS 
  MZS 
  context 
  analyse-h
  progn-context
  type-propagation
  (only (error) common-lisp)
  type-inference
  lzs-to-mzs-fun
  function-call-context
  vector
  function-call
  if-form
  letstar-form
  setq-form
  slot-value
  gutter) 

 syntax
 (eulisp1)
 )



(defmethod finish-a ((con <arg>) form) form)

;--------------------------
; constants
;--------------------------

;          -----       -----        -------------
(defmethod l2m-a ((con <arg>) (form <named-const>))
;          -----       -----        -------------
;
; form = <defined-named-constant>, <imported-named-constant>
;
form)

;          -----       -----        -----
(defmethod l2m-a ((con <arg>) (form <sym>))
;          -----       -----        -----
;
; form = <defined-symbol>, <imported-symbol>
;
form)

;          -----       -----        -----
(defmethod l2m-a ((con <arg>) (form <symbol>))
;          -----       -----        -----
;
; form = slot-name
;
form)

;          -----       -----        ---------
(defmethod l2m-a ((con <arg>) (form <structured-literal>))
;          -----       -----        ---------
; 
; value = <vector>, <pair>, <string>, LITERAL-INSTANCE
;
form)

;          -----       -----        -------
(defmethod l2m-a ((con <arg>) (form <fpi>))
;          -----       -----        -------
;
; <fpi> - single precisition integer
;
form)

;          -----       -----        --------------
(defmethod l2m-a ((con <arg>) (form <double-float>))
;          -----       -----        --------------
form)

;          -----       -----        -----------
(defmethod l2m-a ((con <arg>) (form <character>))
;          -----       -----        -----------
form)

;          -----       -----        ----------
(defmethod l2m-a ((con <arg>) (form <class-def>))
;          -----       -----        -----------
;
;  form = <defined-class>, <imported-class>
;
form)

;          -----       -----        -------
(defmethod l2m-a ((con <arg>) (form <literal-instance>))
;          -----       -----        -------
form)

;          -----       -----        ------------
(defmethod l2m-a ((con <arg>) (form <global-fun>))
;          -----       -----        ------------
  (setf (?function-type form) $data)
form)

;          -----       -----        -----------
(defmethod l2m-a ((con <arg>) (form <local-fun>))
;          -----       -----        -----------
  (lzs2mzs-fun form)
  (if (eq (?function-type form) $closure)
    (make-a-closure-function form (dynamic block))
    form)
)

;          -----       -----        --------------
(defmethod l2m-a ((con <arg>) (form <imported-fun>))
;          -----       -----        --------------
  (setf (?function-type form) $data)
form)

;          -----       -----        ------
(defmethod l2m-a ((con <arg>) (form <special-sys-fun>))
;          -----       -----        ------
  (setf (?function-type form) $data)
form)

;          -----       -----        ---------
(defmethod l2m-a ((con <arg>) (form <global-generic-fun>))
;          -----       -----        ---------
  (setf (?function-type form) $data)
form)

;          -----       -----        --------
(defmethod l2m-a ((con <arg>) (form <local-generic-fun>))
;          -----       -----        --------
  (setf (?function-type form) $data)
form)

;          -----       -----        -----------
(defmethod l2m-a ((con <arg>) (form <imported-generic-fun>))
;          -----       -----        -----------
  (setf (?function-type form) $data)
form)

;          -----       -----        ------
(defmethod l2m-a ((con <arg>) (form <cont>))
;          -----       -----        ------
form)

;          -----       -----        ------
(defmethod l2m-a ((con <arg>) (form <null>))
;          -----       -----        ------
form)

;--------------------------
;   end of constans 
;--------------------------

;--------------------------
;   begin of variables 
;--------------------------
;          -----       -----        ---------
(defmethod l2m-a ((con <arg>) (form <var-ref>))
;          -----       -----        ---------
;
; var = <local-static>, <global-static>, <imported-static>, <dynamic>
;
  (let ((var (?var form)))
    (if (local-static-p var) (rename var)
        var))
)

;--------------------------
;   begin of function call 
;--------------------------

;          -----       -----        -----
(defmethod l2m-a ((con <arg>) (form <app>))
;          -----       -----        -----
;
  (let ((fun (?function form)))
    (if (cont-p fun) (error "continuation in argument position")
;        (if (eq (common-lisp::class-of fun) lzs-mop::<slot-accessor-fun>)
;          (let* ((arglist (?arg-list form))
;                    (arg-num (length arglist))
;                    (var-vec (make-vector (+ arg-num 1)))
;                    (call (make <call> 
;                                :function fun
;                                :arg-num arg-num
;                                :var-descr (make <var-descr>
;                                                 :var-vec var-vec
;                                                 :constant-counter 0))))
;            (lzs2mzs-fun fun)
;               (l2m-call call arglist)
;               (print "************************ Start inline ****************")
;               (inline::inline-a con fun var-vec nil))
          (call-a-function fun (?arg-list form) 
                           nil (?read-glocs form)))))
;)

;--------------------------
;   end of function call
;--------------------------

;          -----       -----        ----------------
(defmethod l2m-a ((con <arg>) (form <set-slot-value>))
;          -----       -----        ----------------
  (set-slot-value-a con form))

;          -----       -----        ----------------
(defmethod l2m-a ((con <arg>) (form <get-slot-value>))
;          -----       -----        ----------------
  (get-slot-value-a con form))

;          -----       -----        -----------
(defmethod l2m-a ((con <arg>) (form <setq-form>))
;          -----       -----        -----------
;
; location = <local-static>, <global-static>, <imported-static>, <dynamic>,
; <defined-named-const>, <imported-named-const>
;
  (setq-form-a con form)
)

;          -----       -----        ------------
(defmethod l2m-a ((con <arg>) (form <progn-form>))
;          -----       -----        ------------
   (l2m-progn con (?form-list form))
)

;          -----       -----        ---------
(defmethod l2m-a ((con <arg>) (form <if-form>))
;          -----       -----        ---------
   (if-form-a con form) 
)

;          -----       -----        -------------
(defmethod l2m-a ((con <arg>) (form <switch-form>))
;          -----       -----        -------------
   (print "<arg> <switch-form> not implemented") 
   ())

;          -----       -----        -----------
(defmethod l2m-a ((con <arg>) (form <let*-form>))
;          -----       -----        -----------
   (letstar-a con form) 
)

;          -----       -----        -------------
(defmethod l2m-a ((con <arg>) (form <labels-form>))
;          -----       -----        -------------
  (l2m-a con (?body form)))

;          -----       -----        -------------
(defmethod l2m-a ((con <arg>) (form <let/cc-form>))
;          -----       -----        -------------
   (print "<arg> <let/cc-form> not implemented") 
   ())

;
;(defmethod l2m-a ((con <arg>) (form <labeled-form>))
;   (print "<arg> <labeled-form> not implemented") 
;   ())
;
;
;(defmethod l2m-a ((con <arg>) (form <tagbody-form>))
;   (print "<arg> <tagbody-form> not implemented") 
;   ())
;
;
;(defmethod l2m-a ((con <arg>) (form <mv-lambda>))
;   (print "<arg> <mv-lambda> not implemented") 
;   ())
;

#module-end
