;;;-*- Mode: Lisp; Package: COMMON-LISP-USER -*-

;; This code was developed in the joint research project APPLY funded by
;; the German Ministry of Research and Technology under the project code
;; ITW9102D5.
;; 
;; Copyright 1994-2010 Fraunhofer ISST
;; 
;; Licensed under the EUPL, Version 1.1 or  as soon they will be approved by the European Commission - subsequent 
;; versions of the EUPL (the "Licence");
;; 
;; You may not use this work except in compliance with the Licence.
;; You may obtain a copy of the Licence at:
;; http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
;; Unless required by applicable law or agreed to in
;; writing, software distributed under the Licence is distributed on an "AS IS" basis,
;; WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
;; 
;; See the Licence for the specific language governing permissions and limitations under the Licence.




;;;To access the export-list of an eulisp-module use the function module-exports
;;;(package el-modules). Usage: see importation from module el2lzs.

(in-package 'user)

(import '(el-modules::module-exports ;(module-name)
          el-modules::module-syntax-exports ;(module-name)
          el-modules::describe-modules ;()
          el-modules::describe-module ;(module-name)
          el-modules::module-hierarchy ;(module-name [:used | :dependent])
          el-modules::find-eulisp-module ;(module-name)
          ))

(import (module-exports (find-eulisp-module 'el2lzs)))
; this provides:
;
; (find-module module-id)
; (find-lexical module-id binding-id)
; (load-module [module-id | path | ""])    {"" on Mac only}
; (pp-module module-id)
; module-env; variable containing all modules of the recently compiled application
;
; !!!attention: the module-id and the function-id must be Eulisp-Symbols, i.e.
; as constants they must be given as ^name

(shadowing-import (module-syntax-exports (find-eulisp-module ^dynamic)))
; this provides the dynamic-Special-Forms of Eulisp

(import (module-exports (find-eulisp-module 'apply-compiler)))

#+:APPLE
(require-eulisp-module 'pplzs)

