;;;-*- Mode: Lisp; Syntax: Common-Lisp; Base: 10; Package: name-of-fun -*-
#|
This code was developed in the joint research project APPLY funded by
the German Ministry of Research and Technology under the project code
ITW9102D5.

Copyright 1994-2010 Fraunhofer ISST

Licensed under the EUPL, Version 1.1 or  as soon they will be approved by the European Commission - subsequent 
versions of the EUPL (the "Licence");

You may not use this work except in compliance with the Licence.
You may obtain a copy of the Licence at:
http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
Unless required by applicable law or agreed to in
writing, software distributed under the Licence is distributed on an "AS IS" basis,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.

See the Licence for the specific language governing permissions and limitations under the Licence.

-----------------------------------------------------------------------------------
TITLE: 
-----------------------------------------------------------------------------------
File:    name-of-fun.em
Version: 1.0 (last modification on Fri May 28 13:12:11 1993)
State:   proposed

DESCRIPTION:
DOCUMENTATION:
NOTES:
REQUIRES:
PROBLEMS:
AUTHOR: Dr. Horst Firedrich
CONTACT: horst.friedrich@isst.fhg.de
HISTORY: 
Log for /tmp_mnt/home/saturn/akind/Lisp/Apply/name-of-fun.em[1.0]
	Mon May 31 20:05:31 1993 hfried@isst proposed $
 

-----------------------------------------------------------------------------------
|#

#module name-of-fun

(import (eulisp1
         accessors
         lzs 
         mzs 
         )

 syntax (eulisp1)

 export (name-of funtype-of)

 )



(defgeneric name-of (fun))

(defmethod name-of ((fun <slot-accessor-fun>))
  (?identifier (?slot fun)))

(defmethod name-of ((fun <slot-init-fun>))
  (?identifier (?slot fun)))

(defmethod name-of ((fun <constructor-fun>))
  (?identifier (?constructor-for fun)))

(defmethod name-of (fun)
  (?identifier fun))

(defgeneric funtype-of (fun))

(defmethod funtype-of ((fun <slot-accessor-fun>))
  "slot-accessor")

(defmethod funtype-of ((fun <slot-init-fun>))
  "slot-init")

(defmethod funtype-of ((fun <constructor-fun>))
  "constructor")

(defmethod funtype-of ((fun <global-fun>))
  "global")

(defmethod funtype-of ((fun <global-generic-fun>))
  "global generic")

(defmethod funtype-of ((fun <local-fun>))
  "local")

(defmethod funtype-of ((fun <imported-fun>))
  "extern")


#module-end