;;;-*- Mode: Lisp; Syntax: Common-Lisp; Base: 10; Package: void-context -*-
#|
This code was developed in the joint research project APPLY funded by
the German Ministry of Research and Technology under the project code
ITW9102D5.

Copyright 1994-2010 Fraunhofer ISST

Licensed under the EUPL, Version 1.1 or  as soon they will be approved by the European Commission - subsequent 
versions of the EUPL (the "Licence");

You may not use this work except in compliance with the Licence.
You may obtain a copy of the Licence at:
http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
Unless required by applicable law or agreed to in
writing, software distributed under the Licence is distributed on an "AS IS" basis,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.

See the Licence for the specific language governing permissions and limitations under the Licence.


-----------------------------------------------------------------------------------
TITLE: 
-----------------------------------------------------------------------------------
File:    void-context.em
Version: 2.0 (last modification on Wed Mar  2 09:29:39 1994)
State:   proposed

DESCRIPTION:
DOCUMENTATION:
NOTES:
REQUIRES:
PROBLEMS:
AUTHOR: Dr. Horst Firedrich
CONTACT: horst.friedrich@isst.fhg.de
HISTORY: 
Log for /export/home/saturn/ukriegel/Eu2C/Apply/void-context.em[2.0]:
  text
[1.1] Thu Mar 18 09:02:29 1993 hfried@isst proposed
  [Fri Mar  5 13:05:59 1993] Intention for change:
[1.2] Wed Mar 24 13:51:16 1993 hfried@isst proposed
  [Thu Mar 18 09:14:20 1993] Intention for change:
[1.3] Thu Mar 25 11:22:56 1993 hfried@isst proposed
  [Wed Mar 24 14:56:34 1993] Intention for change:
  + gen-fun
  new head
[1.4] Tue Apr 13 14:12:01 1993 hfried@isst proposed
  [Thu Mar 25 11:55:42 1993] Intention for change:
[1.5] Mon Jun 21 11:50:41 1993 hfried@isst proposed
  [Tue Apr 13 14:17:44 1993] Intention for change:
[1.6] Tue Sep  7 08:00:06 1993 hfried@isst published
  [Tue Sep  7 07:53:51 1993] Intention for change:
  del not used constant
[1.7] Wed Jan 19 13:07:16 1994 hfried@isst published
  [Mon Jan 17 13:05:11 1994] Intention for change:
  slot-vlaue
[1.8] Thu Mar  3 14:17:39 1994 wheick@isst proposed
  [Wed Mar  2 09:21:11 1994] Intention for change:
  insert eulisp0,1
  <spint> => <fpi>
[2.0] Thu Mar  3 14:17:39 1994 wheick@isst proposed
  [Wed Mar  2 09:21:11 1994] Intention for change:
  insert eulisp0,1
  <spint> => <fpi>

-----------------------------------------------------------------------------------
|#

#module void-context
(import 
 (eulisp1
  SIMPLE-PROGRAMMING
  LZS 
  MZS 
  context 
  analyse-h
  progn-context
  type-propagation
  type-inference
  function-call-context
  (only (append error) common-lisp)
  lzs-to-mzs-fun
  vector
  function-call
  if-form
  setq-form
  letstar-form
  slot-value
  ) 
 ;; typeinfernce
 
 syntax 
 (eulisp1)
 )


;------------------------------

(defmethod finish-a ((con <void>) res) res)

;------------------------------
; constants
;------------------------------

;          -----       ------        -------------
(defmethod l2m-a ((con <void>) (form <named-const>))
;          -----       ------        -------------
;
; form = <defined-named-constant>, <imported-named-constant>
;
  ; (warning "not used constant ~s " form)
 ()  
)


;          -----       ------        -----
(defmethod l2m-a ((con <void>) (form <sym>))
;          -----       ------        -----
;
; form = <defined-symbol>, <imported-symbol>
;
  ; (warning "not used constant ~s " form)
() )

; symbol is a slot-name and in void-context not allowed

;          -----       ------        ----------
(defmethod l2m-a ((con <void>) (form <structured-literal>))
;          -----       ------        ----------
; 
; value = <vector>, <pair>, <string>, LITERAL-INSTANCE
;
  ; (warning "not used constant ~s " form)
() )

;          -----       ------        -------
(defmethod l2m-a ((con <void>) (form <fpi>))
;          -----       ------        -------
;
; <spint> - single precisition integer
;
  ; (warning "not used constant ~s " form)
() )

;          -----       ------        --------------
(defmethod l2m-a ((con <void>) (form <double-float>))
;          -----       ------        --------------
  ; (warning "not used constant ~s " form)
() )

;          -----       ------        -----------
(defmethod l2m-a ((con <void>) (form <character>))
;          -----       ------        -----------
  ; (warning "not used constant ~s " form)
() )

;          -----       ------        ----------
(defmethod l2m-a ((con <void>) (form <class-def>))
;          -----       ------        -----------
;
;  form = <defined-class>, <imported-class>
;
  ; (warning "not used constant ~s " form)
() )

;          -----       ------        --------
(defmethod l2m-a ((con <void>) (form <literal-instance>))
;          -----       ------        --------
  ; (warning "not used constant ~s " form)
() )

;          -----       ------        ------------
(defmethod l2m-a ((con <void>) (form <global-fun>))
;          -----       ------        ------------
  ; (warning "not used constant ~s " form)
() )

;          -----       ------        -----------
(defmethod l2m-a ((con <void>) (form <local-fun>))
;          -----       ------        -----------
  ; (warning "not used constant ~s " form)
 ()
)

;          -----       ------        --------------
(defmethod l2m-a ((con <void>) (form <imported-fun>))
;          -----       ------        --------------
  ; (warning "not used constant ~s " form)
() )

;          -----       ------        -------
(defmethod l2m-a ((con <void>) (form <special-sys-fun>))
;          -----       ------        -------
  ; (warning "not used constant ~s " form)
() )

;          -----       ------        ----------
(defmethod l2m-a ((con <void>) (form <global-generic-fun>))
;          -----       ------        ----------
  ; (warning "not used constant ~s " form)
() )

;          -----       ------        ---------
(defmethod l2m-a ((con <void>) (form <local-generic-fun>))
;          -----       ------        ---------
  ; (warning "not used constant ~s " form)
() )

;          -----       ------        ------------
(defmethod l2m-a ((con <void>) (form <imported-generic-fun>))
;          -----       ------        ------------
  ; (warning "not used constant ~s " form)
() )

;          -----       ------        ------
(defmethod l2m-a ((con <void>) (form <cont>))
;          -----       ------        ------
  ; (warning "not used constant ~s " form)
() )

;          -----       ------        ------
(defmethod l2m-a ((con <void>) (form <null>))
;          -----       ------        ------
;  ; (warning "not used constant ~s " form)
() )

;------------------------------
;   end of constans 
;------------------------------

;------------------------------
;   begin of variables 
;------------------------------

;          -----       ------        ---------
(defmethod l2m-a ((con <void>) (form <var-ref>))
;          -----       ------        ---------
;
; var = <local-static>, <global-static>, <imported-static>, <dynamic>
;
  ; (warning "not used variable ~s " (?var form))
() )

;------------------------------
;   begin of function-application
;------------------------------

;          -----       ------        -----
(defmethod l2m-a ((con <void>) (form <app>))
;          -----       ------        -----
;
; function = <global-fun>, <local-fun>, <imported-fun>, <special-sys-fun>,
; <global-generic-fun>, <local-generic-fun>, imported-generic-fun>, <var-ref>,
; <cont>, <defined-named-constant>, <imported-named-constant>
;
; like arg-context, but with cont-handling
; (not jet impleemnted)
;
  (let ((fun (?function form)))
    (if (cont-p fun) (error "continuation not implemented")
        (call-a-function fun (?arg-list form) nil(?read-glocs form)))))

;          -----       -----        ----------------
(defmethod l2m-a ((con <void>) (form <set-slot-value>))
;          -----       -----        ----------------
  (set-slot-value-a con form))

;          -----       -----        ----------------
(defmethod l2m-a ((con <void>) (form <get-slot-value>))
;          -----       -----        ----------------
  (get-slot-value-a con form))

;          -----       ------        -----------
(defmethod l2m-a ((con <void>) (form <setq-form>))
;          -----       ------        -----------
;
; location = <local-static>, <global-static>, <imported-static>, <dynamic>,
; <defined-named-const>, <imported-named-const>
;
   (setq-form-a con form))

;          -----       ------        ------------
(defmethod l2m-a ((con <void>) (form <progn-form>))
;          -----       ------        ------------
   (l2m-progn con (?form-list form)))

;          -----       ------        ---------
(defmethod l2m-a ((con <void>) (form <if-form>))
;          -----       ------        ---------
   (if-form-a con form))

;          -----       ------        -------------
(defmethod l2m-a ((con <void>) (form <switch-form>))
;          -----       ------        -------------
   (print "<void> <switch-form> not implemented") 
   ())

;          -----       ------        -----------
(defmethod l2m-a ((con <void>) (form <let*-form>))
;          -----       ------        -----------
   (letstar-a con form))

;          -----       ------        -------------
(defmethod l2m-a ((con <void>) (form <labels-form>))
;          -----       ------        -------------
   (l2m-a con (?body form))
)

;          -----       ------        -------------
(defmethod l2m-a ((con <void>) (form <let/cc-form>))
;          -----       ------        -------------
   (print "<void> <let/cc-form> not implemented") 
   ())

;
;(defmethod l2m-a ((con <void>) (form <labeled-form>))
;   (print "<void> <labeled-form> not implemented") 
;   ())
;
;
;(defmethod l2m-a ((con <void>) (form <tagbody-form>))
;   (print "<void> <tagbody-form> not implemented") 
;   ())
;
;
;(defmethod l2m-a ((con <void>) (form <mv-lambda>))
;   (print "<void> <mv-lambda> not implemented") 
;   ())
;

#module-end
