;;;-*- Mode: Lisp; Syntax: Common-Lisp; Base: 10; Package: el-stream -*-
#|

This code was developed in the joint research project APPLY funded by
the German Ministry of Research and Technology under the project code
ITW9102D5.

Copyright 1994-2010 Fraunhofer ISST

Licensed under the EUPL, Version 1.1 or  as soon they will be approved by the European Commission - subsequent 
versions of the EUPL (the "Licence");

You may not use this work except in compliance with the Licence.
You may obtain a copy of the Licence at:
http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
Unless required by applicable law or agreed to in
writing, software distributed under the Licence is distributed on an "AS IS" basis,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.

See the Licence for the specific language governing permissions and limitations under the Licence.

-----------------------------------------------------------------------------------
TITLE: EL-in-CL: standard module stream
-----------------------------------------------------------------------------------
File:    el-stream.em
Version: 2.0 (last modification on Tue Jan  4 11:26:52 1994)
State:   proposed

DESCRIPTION:

DOCUMENTATION:

NOTES:

REQUIRES:

PROBLEMS:
Because there exists a package named STREAM in Franz Allegro, we must take a
different name - el-stream - for our standard module.

AUTHOR:
Ingo Mohr

CONTACT: 

HISTORY: 
Log for /export/home/saturn/ukriegel/Eu2C/EulispModules/el-stream.em[2.0]:
  
[1.1] Wed Mar 10 13:12:05 1993 imohr@isst published
  [Mon Mar  8 14:34:51 1993] Intention for change:
  Log not inside comments
  - with new file header
  - Log-message inside balanced comment
[1.2] Tue Jan  4 11:27:06 1994 wheick@isst published
  [Fri Nov 12 14:36:11 1993] Intention for change:
  new module header
[2.0] Tue Jan  4 11:27:06 1994 wheick@isst proposed
  [Fri Nov 12 14:36:11 1993] Intention for change:
  new module header

-----------------------------------------------------------------------------------
|#

#module el-stream

(import
 ((except (let) eulisp-kernel) ; zur Sicherheit, da noch nicht zwischen export
  ; und syntax-export unterschieden wird
  (only (*package*) common-lisp)
  (rename ((read cl:read)) common-lisp))
 
 syntax
 ((except (let) eulisp-kernel)
  (only (let &optional declare special) common-lisp)
  (rename ((defun cl:defun)) common-lisp))
 
 export 
 (read)
 
 expose 
 ((only (streamp close read-char read-byte peek-char write-char write-byte
                 print ) 
    common-lisp))
 )

(cl:defun read (&optional stream)
(let ((*package* $eulisp-symbol-package))
  (declare (special *package*))
  (if stream
    (read-eulisp stream)
    (read-eulisp))))

#module-end
